#include <glib-unix.h>
#include <assert.h>

#include "login-shell.h"

static gchar **g_shell_argv;

static gboolean restart(gpointer d)
{
    (void)d;
    gint i, fdlimit;

    fdlimit = (int)sysconf(_SC_OPEN_MAX);
    g_debug("reload: closing fd's %d to %d", STDERR_FILENO + 1, fdlimit);
    for (i = STDERR_FILENO + 1; i < fdlimit; i++)
    {
        fcntl(i, F_SETFD, FD_CLOEXEC);
    }
    g_debug("reload: exec: %s", g_shell_argv[0]);
    execvp(g_shell_argv[0], g_shell_argv);
    exit(1);
    return FALSE;
}

int main(int argc, char *argv[])
{
    g_shell_argv = g_malloc0(sizeof(gchar *) * (argc + 1));
    for (int i = 0; i < argc; i++)
    {
        g_shell_argv[i] = argv[i];
    }
    g_unix_signal_add(SIGHUP, (GSourceFunc)restart, NULL);    
    DiyaLoginShell* shell = DIYA_LOGIN_SHELL(g_object_new(DIYA_TYPE_LOGIN_SHELL, "name", "dev.iohub.diya.login-shell", NULL));
    return diya_shell_run(DIYA_SHELL(shell), argc, argv);
}
